//
//  FNGitMergeTreeEntry.h
//  FNGit
//
//  Created by Heiko Witte on 20.10.17.
//  Copyright © 2017 Fournova GmbH. All rights reserved.
//

#import "FNGitFileEntry.h"
#import "FNGitDefines.h"

@interface FNGitMergeTreeEntry : FNGitFileEntry
@property (nonatomic, readonly) FNGitMergeTreeEntryType type;
@property (nonatomic, readonly) NSString *diff;
@property (nonatomic, readonly, getter=isBinaryFile) BOOL binaryFile;

@property (nonatomic, readonly) FNGitFileEntry *baseVersion;
@property (nonatomic, readonly) FNGitFileEntry *ourVersion;
@property (nonatomic, readonly) FNGitFileEntry *theirVersion;
@property (nonatomic, readonly) FNGitFileEntry *resultVersion;

@property (nonatomic, readonly) BOOL hasConflict;

+ (instancetype)mergeTreeEntryWithType:(FNGitMergeTreeEntryType)type
                                  diff:(NSString *)diff
                           baseVersion:(FNGitFileEntry *)baseVersion
                            ourVersion:(FNGitFileEntry *)ourVersion
                            theirVersion:(FNGitFileEntry *)theirVersion
                          resultVersion:(FNGitFileEntry *)resultVersion
                          isBinaryFile:(BOOL)isBinaryFile
                            repository:(FNGitRepository *)repository;

- (instancetype)initWithType:(FNGitMergeTreeEntryType)type
                                  diff:(NSString *)diff
                           baseVersion:(FNGitFileEntry *)baseVersion
                            ourVersion:(FNGitFileEntry *)ourVersion
                          theirVersion:(FNGitFileEntry *)theirVersion
                         resultVersion:(FNGitFileEntry *)resultVersion
                          isBinaryFile:(BOOL)isBinaryFile
                            repository:(FNGitRepository *)repository;
@end

#import "FNGitMergeTreeEntry+FNGitMergeTreeOutputParserResultItem.h"
